diff -r 1e55e1aa8b7f sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_input.c	Fri Jul 11 13:32:06 2014 +1000
@@ -2390,6 +3441,12 @@
 			    mtod(m, const char *), tp, th);
 			cc_conn_init(tp);
 			tcp_timer_activate(tp, TT_KEEP, TP_KEEPIDLE(tp));
+			if (to.to_flags & TOF_MPTCP) {
+				/* passive open */
+				if(tp->mpc && tp->sent_capable) {
+					mp_init_established(tp);
+				}
+			}
 		}
 		/*
 		 * If segment contains data or ACK, will call tcp_reass()
@@ -2410,6 +3467,17 @@
 	 * more up to date window information we update our window information.
 	 */
 	case TCPS_ESTABLISHED:
+		if(!IS_MASTER_TP(tp) && tp->sf_state == MPS_PRE_ESTABLISHED) {
+			tp->mp_active = 1;
+			tp->infinite_map = 0;
+			tp->sf_state = MPS_ESTABLISHED;
+			mp_debug(MPSESSION, 1, 0, "%s:%d new mp connection for tp: %p: \n",
+                __func__, __LINE__, tp);
+//			atomic_add_int(&tp->t_mpcb->subflow_cnt,1);
+			mp_debug(MPSESSION, 4, 0, "%s: set subflow as mp_active\n",
+			    __func__);
+		}
+		/* drop through */
 	case TCPS_FIN_WAIT_1:
 	case TCPS_FIN_WAIT_2:
 	case TCPS_CLOSE_WAIT:
@@ -2441,6 +3509,7 @@
 					tp->t_dupacks = 0;
 					break;
 				}
+
 				TCPSTAT_INC(tcps_rcvdupack);
 				/*
 				 * If we have outstanding data (other than
@@ -2475,14 +3544,14 @@
 					tp->t_dupacks = 0;
 				else if (++tp->t_dupacks > tcprexmtthresh ||
 				     IN_FASTRECOVERY(tp->t_flags)) {
-					cc_ack_received(tp, th, CC_DUPACK);
+					cc_ack_received(tp, th, CC_DUPACK, acked);
 					if ((tp->t_flags & TF_SACK_PERMIT) &&
 					    IN_FASTRECOVERY(tp->t_flags)) {
 						int awnd;
 						
 						/*
 						 * Compute the amount of data in flight first.
-						 * We can inject new data into the pipe iff 
+						 * We can inject new data into the pipe if
 						 * we have less than 1/2 the original window's
 						 * worth of data in flight.
 						 */
@@ -2493,13 +3562,16 @@
 							if (tp->snd_cwnd > tp->snd_ssthresh)
 								tp->snd_cwnd = tp->snd_ssthresh;
 						}
+						if (tp->t_dupacks == (tcprexmtthresh +1))
+							mp_debug(MPSESSION, 4, 0,
+							    "%s: exceeded rxthresh. awnd %d, cwnd %u\n",
+								__func__, awnd, (uint32_t) tp->snd_cwnd);
 					} else
 						tp->snd_cwnd += tp->t_maxseg;
 					(void) tcp_output(tp);
 					goto drop;
 				} else if (tp->t_dupacks == tcprexmtthresh) {
 					tcp_seq onxt = tp->snd_nxt;
-
 					/*
 					 * If we're doing sack, check to
 					 * see if we're already in sack
@@ -2521,9 +3593,10 @@
 					}
 					/* Congestion signal before ack. */
 					cc_cong_signal(tp, th, CC_NDUPACK);
-					cc_ack_received(tp, th, CC_DUPACK);
+					cc_ack_received(tp, th, CC_DUPACK, acked);
 					tcp_timer_activate(tp, TT_REXMT, 0);
 					tp->t_rtttime = 0;
+					tp->snd_nxt = th->th_ack;
 					if (tp->t_flags & TF_SACK_PERMIT) {
 						TCPSTAT_INC(
 						    tcps_sack_recovery_episode);
@@ -2532,7 +3605,6 @@
 						(void) tcp_output(tp);
 						goto drop;
 					}
-					tp->snd_nxt = th->th_ack;
 					tp->snd_cwnd = tp->t_maxseg;
 					(void) tcp_output(tp);
 					KASSERT(tp->snd_limited <= 2,
@@ -2545,7 +3617,7 @@
 						tp->snd_nxt = onxt;
 					goto drop;
 				} else if (V_tcp_do_rfc3042) {
-					cc_ack_received(tp, th, CC_DUPACK);
+					cc_ack_received(tp, th, CC_DUPACK, acked);
 					u_long oldcwnd = tp->snd_cwnd;
 					tcp_seq oldsndmax = tp->snd_max;
 					u_int sent;
@@ -2574,12 +3646,12 @@
 						(void) tcp_output(tp);
 					sent = tp->snd_max - oldsndmax;
 					if (sent > tp->t_maxseg) {
-						KASSERT((tp->t_dupacks == 2 &&
-						    tp->snd_limited == 0) ||
-						   (sent == tp->t_maxseg + 1 &&
-						    tp->t_flags & TF_SENTFIN),
-						    ("%s: sent too much",
-						    __func__));
+//						KASSERT((tp->t_dupacks == 2 &&
+//						    tp->snd_limited == 0) ||
+//						   (sent == tp->t_maxseg + 1 &&
+//						    tp->t_flags & TF_SENTFIN),
+//						    ("%s: sent too much",
+//						    __func__));
 						tp->snd_limited = 2;
 					} else if (sent > 0)
 						++tp->snd_limited;
@@ -2589,7 +3661,7 @@
 			} else
 				tp->t_dupacks = 0;
 			break;
-		}
+		} /* end dup-ack processing */
 
 		KASSERT(SEQ_GT(th->th_ack, tp->snd_una),
 		    ("%s: th_ack <= snd_una", __func__));
@@ -2601,9 +3673,9 @@
 		if (IN_FASTRECOVERY(tp->t_flags)) {
 			if (SEQ_LT(th->th_ack, tp->snd_recover)) {
 				if (tp->t_flags & TF_SACK_PERMIT)
-					tcp_sack_partialack(tp, th);
+					tcp_sack_partialack(tp, th, acked);
 				else
-					tcp_newreno_partial_ack(tp, th);
+					tcp_newreno_partial_ack(tp, th, acked);
 			} else
 				cc_post_recovery(tp, th);
 		}
@@ -2622,6 +3694,7 @@
 			 */
 			tp->t_flags &= ~TF_NEEDSYN;
 			tp->snd_una++;
+
 			/* Do window scaling? */
 			if ((tp->t_flags & (TF_RCVD_SCALE|TF_REQ_SCALE)) ==
 				(TF_RCVD_SCALE|TF_REQ_SCALE)) {
@@ -2633,7 +3706,6 @@
 process_ACK:
 		INP_WLOCK_ASSERT(tp->t_inpcb);
 
-		acked = BYTES_THIS_ACK(tp, th);
 		TCPSTAT_INC(tcps_rcvackpack);
 		TCPSTAT_ADD(tcps_rcvackbyte, acked);
 
@@ -2688,33 +3760,29 @@
 			tcp_timer_activate(tp, TT_REXMT, tp->t_rxtcur);
 
 		/*
-		 * If no data (only SYN) was ACK'd,
-		 *    skip rest of ACK processing.
+		 * If no data (only SYN or FIN) was ACK'd,
+		 * skip rest of ACK processing.
 		 */
-		if (acked == 0)
+		if (acked == 0 && (FAKE_BYTES_THIS_ACK(tp, th) == 0))
 			goto step6;
 
+		acked -= (oursynisacked ? 1 : 0);
+
 		/*
 		 * Let the congestion control algorithm update congestion
 		 * control related information. This typically means increasing
 		 * the congestion window.
 		 */
-		cc_ack_received(tp, th, CC_ACK);
-
-		SOCKBUF_LOCK(&so->so_snd);
-		if (acked > so->so_snd.sb_cc) {
-			tp->snd_wnd -= so->so_snd.sb_cc;
-			mfree = sbcut_locked(&so->so_snd,
-			    (int)so->so_snd.sb_cc);
+		cc_ack_received(tp, th, CC_ACK, acked);
+
+		if ((tp->t_flags & TF_SENTFIN) && (th->th_ack == tp->snd_max)) {
+			tp->snd_wnd -= ulmin(tp->snd_wnd, acked);
 			ourfinisacked = 1;
 		} else {
-			mfree = sbcut_locked(&so->so_snd, acked);
 			tp->snd_wnd -= acked;
 			ourfinisacked = 0;
 		}
-		/* NB: sowwakeup_locked() does an implicit unlock. */
-		sowwakeup_locked(so);
-		m_freem(mfree);
+		
 		/* Detect una wraparound. */
 		if (!IN_RECOVERY(tp->t_flags) &&
 		    SEQ_GT(tp->snd_una, tp->snd_recover) &&
@@ -2725,7 +3793,18 @@
 		    SEQ_GEQ(th->th_ack, tp->snd_recover)) {
 			EXIT_RECOVERY(tp->t_flags);
 		}
+
+		/* XXXNJW to be changed */
+		if (tp->infinite_map) {
+			KASSERT(acked <=  so->so_snd.sb_cc,
+			    ("sb_cc: %d, acked: %d", so->so_snd.sb_cc, acked));
+			atomic_subtract_int(&so->so_snd.sb_cc, acked);
+		}
+		tcp_ackmap(tp, acked, (to.to_mopts.mpo_flags & MPOF_DATA_ACK) ?
+		    to.to_mopts.data_ack_num : 0);
+
 		tp->snd_una = th->th_ack;
+
 		if (tp->t_flags & TF_SACK_PERMIT) {
 			if (SEQ_GT(tp->snd_una, tp->snd_recover))
 				tp->snd_recover = tp->snd_una;
@@ -2753,8 +3832,15 @@
 				 * we should release the tp also, and use a
 				 * compressed state.
 				 */
+				mp_debug(MPSESSION, 1, 0,
+				    "%s: FIN is acked, enter FINWAIT_2 tp %p\n", __func__, tp);
 				if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
-					soisdisconnected(so);
+					// call into mptcp layer function to do this
+					// are any subflows in state < TCPS_FIN_WAIT_2
+					// if so then skip past the soisdisconnected
+					// (in fact soisdiconnected called from the
+					// mp_layer function)
+
 					tcp_timer_activate(tp, TT_2MSL,
 					    (tcp_fast_finwait2_recycle ?
 					    tcp_finwait2_timeout :
@@ -2831,7 +3917,7 @@
 		 * actually wanting to send this much urgent data.
 		 */
 		SOCKBUF_LOCK(&so->so_rcv);
-		if (th->th_urp + so->so_rcv.sb_cc > sb_max) {
+		if (th->th_urp + (so->so_rcv.sb_cc) > sb_max) {
 			th->th_urp = 0;			/* XXX */
 			thflags &= ~TH_URG;		/* XXX */
 			SOCKBUF_UNLOCK(&so->so_rcv);	/* XXX */
@@ -2853,7 +3939,7 @@
 		 */
 		if (SEQ_GT(th->th_seq+th->th_urp, tp->rcv_up)) {
 			tp->rcv_up = th->th_seq + th->th_urp;
-			so->so_oobmark = so->so_rcv.sb_cc +
+			so->so_oobmark = (so->so_rcv.sb_cc) +
 			    (tp->rcv_up - tp->rcv_nxt) - 1;
 			if (so->so_oobmark == 0)
 				so->so_rcv.sb_state |= SBS_RCVATMARK;
@@ -2886,7 +3972,7 @@
 
 	/*
 	 * Process the segment text, merging it into the TCP sequencing queue,
-	 * and arranging for acknowledgment of receipt if necessary.
+	 * and arranging for acknowledgement of receipt if necessary.
 	 * This process logically involves adjusting tp->rcv_wnd as data
 	 * is presented to the user (this happens in tcp_usrreq.c,
 	 * case PRU_RCVD).  If a FIN has already been received on this
@@ -2896,7 +3982,13 @@
 	    TCPS_HAVERCVDFIN(tp->t_state) == 0) {
 		tcp_seq save_start = th->th_seq;
 		m_adj(m, drop_hdrlen);	/* delayed header drop */
+
+		if (thflags & TH_FIN)
+			mp_debug(MPSESSION, 1, 0, "%s:%d: got FIN on tp %p\n", __func__,
+			    __LINE__, tp);
+
 		/*
+		 * XXXNJW: Need to adapt this comment
 		 * Insert segment which includes th into TCP reassembly queue
 		 * with control block tp.  Set thflags to whether reassembly now
 		 * includes a segment with FIN.  This handles the common case
@@ -2908,35 +4000,23 @@
 		 * immediately when segments are out of order (so
 		 * fast retransmit can work).
 		 */
-		if (th->th_seq == tp->rcv_nxt &&
-		    LIST_EMPTY(&tp->t_segq) &&
-		    TCPS_HAVEESTABLISHED(tp->t_state)) {
-			if (DELAY_ACK(tp, tlen))
-				tp->t_flags |= TF_DELACK;
-			else
+		 thflags = tcp_reass(tp, th, &tlen, m);
+			if (TCPS_HAVEESTABLISHED(tp->t_state) &&
+					!tp->t_segq->disordered) {
+				if (DELAY_ACK(tp, tlen))
+					tp->t_flags |= TF_DELACK;
+				else
+					tp->t_flags |= TF_ACKNOW;
+				TCPSTAT_INC(tcps_rcvpack);
+				TCPSTAT_ADD(tcps_rcvbyte, tlen);
+			} else {
+				/* disordered bytes in list
+				 *
+				 * dont want to set FIN just yet
+				 */
 				tp->t_flags |= TF_ACKNOW;
-			tp->rcv_nxt += tlen;
-			thflags = th->th_flags & TH_FIN;
-			TCPSTAT_INC(tcps_rcvpack);
-			TCPSTAT_ADD(tcps_rcvbyte, tlen);
-			ND6_HINT(tp);
-			SOCKBUF_LOCK(&so->so_rcv);
-			if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
-				m_freem(m);
-			else
-				sbappendstream_locked(&so->so_rcv, m);
-			/* NB: sorwakeup_locked() does an implicit unlock. */
-			sorwakeup_locked(so);
-		} else {
-			/*
-			 * XXX: Due to the header drop above "th" is
-			 * theoretically invalid by now.  Fortunately
-			 * m_adj() doesn't actually frees any mbufs
-			 * when trimming from the head.
-			 */
-			thflags = tcp_reass(tp, th, &tlen, m);
-			tp->t_flags |= TF_ACKNOW;
-		}
+			}
+
 		if (tlen > 0 && (tp->t_flags & TF_SACK_PERMIT))
 			tcp_update_sack_list(tp, save_start, save_start + tlen);
 #if 0
@@ -2962,7 +4042,15 @@
 	 */
 	if (thflags & TH_FIN) {
 		if (TCPS_HAVERCVDFIN(tp->t_state) == 0) {
-			socantrcvmore(so);
+			mp_debug(MPSESSION, 1, 0, "%s:%d: got FIN on tp %p\n", __func__,
+			   __LINE__, tp);
+			/*
+			 * XXXNJW: Should only set SBS_CANTRCVMORE when the DFIN is rx'd
+			 * Will set all subflows tp can't receive more. TBD: on DFIN only
+			 */
+			if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0)
+				mp_set_cantrcvmore(tp);
+
 			/*
 			 * If connection is half-synchronized
 			 * (ie NEEDSYN flag on) then delay ACK,
@@ -3186,8 +4274,11 @@
 tcp_dooptions(struct tcpopt *to, u_char *cp, int cnt, int flags)
 {
 	int opt, optlen;
-
+	uint8_t subtype;
+
+	to->to_mopts.mpo_flags = 0;
 	to->to_flags = 0;
+	
 	for (; cnt > 0; cnt -= optlen, cp += optlen) {
 		opt = cp[0];
 		if (opt == TCPOPT_EOL)
@@ -3231,6 +4322,13 @@
 			    (char *)&to->to_tsecr, sizeof(to->to_tsecr));
 			to->to_tsecr = ntohl(to->to_tsecr);
 			break;
+		case TCPOPT_MPTCP:
+			bcopy((char *)cp + 2,
+					(char *)&subtype, sizeof(subtype));
+			if (optlen > MAX_MP_OPLEN)
+				continue;
+			mp_dosubtypes(to, subtype, cp, opt, optlen, flags);
+			break;
 #ifdef TCP_SIGNATURE
 		/*
 		 * XXX In order to reply to a host which has set the
@@ -3688,7 +4786,7 @@
  * be started again.
  */
 static void
-tcp_newreno_partial_ack(struct tcpcb *tp, struct tcphdr *th)
+tcp_newreno_partial_ack(struct tcpcb *tp, struct tcphdr *th, uint32_t acked)
 {
 	tcp_seq onxt = tp->snd_nxt;
 	u_long  ocwnd = tp->snd_cwnd;
@@ -3702,7 +4800,7 @@
 	 * Set snd_cwnd to one segment beyond acknowledged offset.
 	 * (tp->snd_una has not yet been updated when this function is called.)
 	 */
-	tp->snd_cwnd = tp->t_maxseg + BYTES_THIS_ACK(tp, th);
+	tp->snd_cwnd = tp->t_maxseg + acked;
 	tp->t_flags |= TF_ACKNOW;
 	(void) tcp_output(tp);
 	tp->snd_cwnd = ocwnd;
@@ -3712,8 +4810,8 @@
 	 * Partial window deflation.  Relies on fact that tp->snd_una
 	 * not updated yet.
 	 */
-	if (tp->snd_cwnd > BYTES_THIS_ACK(tp, th))
-		tp->snd_cwnd -= BYTES_THIS_ACK(tp, th);
+	if (tp->snd_cwnd > acked)
+		tp->snd_cwnd -= acked;
 	else
 		tp->snd_cwnd = 0;
 	tp->snd_cwnd += tp->t_maxseg;
